* PROCEDURE d'initialisation de l'application ATFDEMO

* Operating System codes
#DEFINE	OS_W32S				1
#DEFINE	OS_NT				2
#DEFINE	OS_WIN95			3
#DEFINE	OS_MAC				4
#DEFINE	OS_DOS				5
#DEFINE	OS_UNIX				6

* DLL Paths for various operating systems
#DEFINE DLLPATH_32S			"\SYSTEM\"		&&used for ODBC only
#DEFINE DLLPATH_NT			"\SYSTEM32\"
#DEFINE DLLPATH_WIN95		"\SYSTEM\"

* DLL files used to read INI files
#DEFINE	DLL_KERNEL_W32S		"W32SCOMB.DLL"
#DEFINE	DLL_KERNEL_NT		"KERNEL32.DLL"
#DEFINE	DLL_KERNEL_WIN95	"KERNEL32.DLL"

* DLL files used to read registry
#DEFINE	DLL_ADVAPI_W32S		"W32SCOMB.DLL"
#DEFINE	DLL_ADVAPI_NT		"ADVAPI32.DLL"
#DEFINE	DLL_ADVAPI_WIN95	"ADVAPI32.DLL"

* DLL files used to read ODBC info
#DEFINE DLL_ODBC_W32S		"ODBC32.DLL"
#DEFINE DLL_ODBC_NT			"ODBC32.DLL"
#DEFINE DLL_ODBC_WIN95		"ODBC32.DLL"

* Registry roots
#DEFINE HKEY_CLASSES_ROOT           -2147483648  && BITSET(0,31)
#DEFINE HKEY_CURRENT_USER           -2147483647  && BITSET(0,31)+1
#DEFINE HKEY_LOCAL_MACHINE          -2147483646  && BITSET(0,31)+2
#DEFINE HKEY_USERS                  -2147483645  && BITSET(0,31)+3

* Misc
#DEFINE APP_PATH_KEY		"\Shell\Open\Command"
#DEFINE OLE_PATH_KEY		"\Protocol\StdFileEditing\Server"

*#DEFINE VFP_OPTIONS_KEY		"Software\Microsoft\VisualFoxPro\6.0\Options"
*#DEFINE VFP_OPT32S_KEY		"VisualFoxPro\6.0\Options"
#DEFINE CURVER_KEY			"\CurVer"
#DEFINE ODBC_DATA_KEY		"Software\ODBC\ODBC.INI\"
#DEFINE ODBC_DRVRS_KEY		"Software\ODBC\ODBCINST.INI\"
#DEFINE SQL_FETCH_NEXT		1
#DEFINE SQL_NO_DATA			100
#DEFINE VFP_OPTIONS_KEY1	"Software\Microsoft\VisualFoxPro\"
#DEFINE VFP_OPTIONS_KEY2	"\Options"
#DEFINE VFP_OPTIONS_KEY		"Software\Microsoft\VisualFoxPro\9.0\Options"
#DEFINE VFP_OPT32S_KEY		"VisualFoxPro\9.0\Options"

* Error Codes
#DEFINE ERROR_SUCCESS		0	&& OK
#DEFINE ERROR_EOF 			259 && no more entries in key

* Note these next error codes are specific to this Class, not DLL
#DEFINE ERROR_NOAPIFILE		-101	&& DLL file to check registry not found
#DEFINE ERROR_KEYNOREG		-102	&& key not registered
#DEFINE ERROR_BADPARM		-103	&& bad parameter passed
#DEFINE ERROR_NOENTRY		-104	&& entry not found
#DEFINE	ERROR_BADKEY		-105	&& bad key passed
#DEFINE	ERROR_NONSTR_DATA	-106	&& data type for value is not a data string
#DEFINE ERROR_BADPLAT		-107	&& platform not supported
#DEFINE ERROR_NOINIFILE		-108	&& DLL file to check INI not found
#DEFINE ERROR_NOINIENTRY	-109	&& No entry in INI file
#DEFINE ERROR_FAILINI		-110	&& failed to get INI entry
#DEFINE ERROR_NOPLAT		-111	&& call not supported on this platform
#DEFINE ERROR_NOODBCFILE	-112	&& DLL file to check ODBC not found
#DEFINE ERROR_ODBCFAIL		-113	&& failed to get ODBC environment

* Data types for keys
#DEFINE REG_SZ 				1	&& Data string
#DEFINE REG_BINARY 			3	&& Binary data in any form.
#DEFINE REG_DWORD 			4	&& A 32-bit number.

* Data types labels
#DEFINE REG_BINARY_LOC		"*Binary*"			&& Donnes binaires dans tous les formulaires.
#DEFINE REG_DWORD_LOC 		"*Dword*"			&& Nombre de 32 bits.
#DEFINE REG_UNKNOWN_LOC		"*Unknown type*"	&& Type inconnu

* FoxPro ODBC drivers
#DEFINE FOXODBC_25			"FoxPro Files (*.dbf)"
#DEFINE FOXODBC_26			"Microsoft FoxPro Driver (*.dbf)"
#DEFINE FOXODBC_30			"Microsoft Visual FoxPro Driver"

* LIMITATION MEMOIRE FOXPRO  64MO en mode Lan
=SYS(3050, 1, 64 * 1024 * 1024)
=SYS(3050, 2, 16 * 1024 * 1024)

IF _VFP.STARTMODE > 1
	cDefault = ADDBS(SYS(5) + SYS(2003))
ELSE
	cDefault = ADDBS(JUSTPATH(JUSTPATH(SYS(16))))
ENDIF
_SCREEN.ADDPROPERTY("_locale", m.cDefault)
RELEASE cDefault
SET DEFAULT TO (_SCREEN._locale)
SET PATH TO ".\progs, .\progs\libs, .\progs\bitmaps, .\progs\forms, .\progs\menu" ADDITIVE
SET PROCEDURE TO utile.prg, atfInit.prg ADDITIVE
SET CLASSLIB TO gwSAV.vcx ADDITIVE
SET TALK OFF

* Ouverture des API
EXTERNAL LIBRARY foxtools.fll
STORE "foxtools.fll" TO clibrairie
SET LIBRARY TO (clibrairie) ADDITIVE
RELEASE clibrairie

* Dclaration de DLL externes
DECLARE INTEGER ShellExecute IN shell32.DLL ;
	INTEGER hndWin, ;
	STRING cAction, ;
	STRING cFileName, ;
	STRING cParams, ;
	STRING cDir, ;
	INTEGER nShowWin
DECLARE INTEGER GetPrivateProfileString IN Win32API ;
	STRING,STRING,STRING,STRING,INTEGER,STRING
DECLARE INTEGER WritePrivateProfileString IN Win32API ;
	STRING,STRING,STRING,STRING
DECLARE INTEGER GetProfileString IN Win32API ;
	STRING,STRING,STRING,STRING,INTEGER
DECLARE INTEGER WriteProfileString IN Win32API ;
	STRING,STRING,STRING
DECLARE Sleep IN kernel32 INTEGER dwMilliseconds
DECLARE INTEGER Sleep IN win32api INTEGER

********************
* Gestion gnrale *
********************
WITH _SCREEN
	* Connexion ODBC
	.ADDPROPERTY("_gnconnect", 0)
	* Mode
	.ADDPROPERTY("_debug","DEBUG")
	* Nom de la base de donnes
	.ADDPROPERTY("_dbcdatavfp","datavfp")
	* Chemin du lecteur rseau
	.ADDPROPERTY("_disque","DATA\")
	* Nom du fichier trace
	.ADDPROPERTY("_file_trace","trace.log")
	* Url du site WEB
	.ADDPROPERTY("_UrlWeb","http://localhost/atfdemo.atf")
	* Rpertoire des images par dfaut
	.ADDPROPERTY("_image","IMAGE\")
	* Rpertoire des traces par dfaut
	.ADDPROPERTY("_trace","TRACE\")
	* Titre application par dfaut
	.ADDPROPERTY("_title","ATFDEMO")
	* Version application par dfaut
	.ADDPROPERTY("_version")
	* Rpertoire des REPORTs par dfaut
	.ADDPROPERTY("_chemin_etat","REPORT\")
	* Rpertoire des exportations par dfaut
	.ADDPROPERTY("_chemin_export","EXPORT\")
	* Rpertoire des courriels par dfaut
	.ADDPROPERTY("_chemin_courriel","COURRIEL\")
	* Nom de la machine
	.ADDPROPERTY("_machine_name")
	* Recherche du nom de la machine sur le rseau
	oShell = CREATEOBJECT("WScript.Shell")
	._machine_name = m.oShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
	oShell = NULL
	RELEASE oShell
	* Oprateur courant
	.ADDPROPERTY("_clepkUser", 0)
	* N de tl de l'assistance
	.ADDPROPERTY("_TelAssistance","(33) 02 99 90 40 40")
ENDWITH

* Permet aux requtes de fermer et ouvrir des bases sans avertissement
SET SAFETY OFF
SET ESCAPE OFF
* Permet aux tables d'tre utilises en rseaux
SET EXCLUSIVE OFF
SET MULTILOCK ON
SET REPROCESS TO AUTOMATIC
SET EXACT OFF
ON SHUTDOWN DO raz_prg
SET DATE FRENCH
SET HOURS TO 24
RETURN initialise_application()

* FONCTION d'initialisation des paramtres de lancement de l'application
PROCEDURE initialise_application
	LOCAL cFiChierIni AS STRING

	WITH _SCREEN
		cFiChierIni = ._locale + "ATFDEMO.INI"
		* Chemin du lecteur de disque ou sont placs les fichiers de la base VFP DATAVFP
		._disque = ADDBS(GETPROF(m.cFiChierIni, "Chemin", "CheminData"))
		IF NOT EMPTY(._disque) AND NOT DIRECTORY(._disque)
			._disque = ADDBS(._locale + 'DATA')
		ENDIF	
	ENDWITH
	IF DIRECTORY(_SCREEN._disque)
		WITH _SCREEN
			cFiChierIni = ._disque + "GLOBAL.INI"
			* Ecriture du dossier des fichiers temporaires pour infos ncessaires  la maintenance
			=putprof(m.cFiChierIni, "TMP", "DOSSIER", FULLPATH(SYS(2023))))
			* Traitement de la version de l'application
			._debug = GETPROF(m.cFiChierIni, "Mode", "Version")
			* Url d'accs au site WEB
			._urlweb = GETPROF(m.cFiChierIni, 'Serveur', 'urlweb')
			* Rpertoire du fichier trace
			._trace = GETPROF(m.cFiChierIni, 'Chemin', 'CheminTrace')
			._trace = ADDBS(ICASE(EMPTY(._trace), ._disque + "trace\", EMPTY(JUSTDRIVE(._trace)), ._disque + ._trace, ._trace))
			IF NOT DIRECTORY(._trace)
				MKDIR (._trace)
			ENDIF
			* Chemin d'accs aux tats d'impression
			._chemin_etat = GETPROF(m.cFiChierIni, "Chemin", "CheminEtat")
			._chemin_etat  = ADDBS(ICASE(EMPTY(._chemin_etat), ._disque + "reports\", EMPTY(JUSTDRIVE(._chemin_etat)), ._disque + ._chemin_etat, ._chemin_etat))
			IF NOT DIRECTORY(._chemin_etat)
				MKDIR (._chemin_etat)
			ENDIF
			* Chemin d'accs bibliothque des images
			._image = GETPROF(m.cFiChierIni, "Chemin", "CheminImage")
			._image = ADDBS(ICASE(EMPTY(._image), ._disque + "image\", EMPTY(JUSTDRIVE(._image)), ._disque + ._image, ._image))
			IF NOT DIRECTORY(._image)
				MKDIR (._image)
			ENDIF
			* Rpertoire des fichiers courriel
			._chemin_courriel = GETPROF(m.cFiChierIni, 'Chemin', 'CheminCourriel')
			._chemin_courriel = ADDBS(ICASE(EMPTY(._chemin_courriel), ._disque + "courriel\", EMPTY(JUSTDRIVE(._chemin_courriel)), ._disque + ._chemin_courriel, ._chemin_courriel))
			IF NOT DIRECTORY(._chemin_courriel)
				MKDIR (._chemin_courriel)
			ENDIF
			* Rpertoire des fichiers d'exportation
			._chemin_export = GETPROF(m.cFiChierIni, 'Chemin', 'CheminExport')
			._chemin_export = ADDBS(ICASE(EMPTY(._chemin_export), ._disque + "export\", EMPTY(JUSTDRIVE(._chemin_export)), ._disque + ._chemin_export, ._chemin_export))
			IF NOT DIRECTORY(._chemin_export)
				MKDIR (._chemin_export)
			ENDIF
			* Rcupration du N de tlphone de l'assistance pour le dblocage des cls
			._TelAssistance = GETPROF(m.cFiChierIni, 'Mode', 'Assistance')
			* Affectation des chemins par dfaut
			SET PATH TO (._disque) ADDITIVE
			SET PATH TO (._trace) ADDITIVE
			SET PATH TO (._image) ADDITIVE
			SET PATH TO (._chemin_courriel) ADDITIVE
			SET PATH TO (._chemin_export) ADDITIVE
			SET PATH TO (._chemin_etat) ADDITIVE
		ENDWITH
		* Ouverture de la base de donnes
		=open_dbc()
	ELSE
		=STRTOFILE(TTOC(DATETIME(), 2) + "-->Chemin d'accs base de donnes inconnu.." + CHR(13)+CHR(10), _SCREEN._locale + "erreur.log", 1)
		CLEAR EVENTS
	ENDIF
ENDPROC
