* Procdure de fermeture de l'application
PROCEDURE raz_prg
	LOCAL cTitre AS STRING

	cTitre = IIF(VARTYPE(_SCREEN._titre) == "C", _SCREEN._title, '')
	=ecrit_trace("ARRET " + m.cTitre)
	* Dconnexion ODBC sur la base de donnes du serveur SQL
	IF TYPE('_SCREEN._gnconnect') == 'N' AND _SCREEN._gnconnect> 0
		SQLDISCONNECT(_SCREEN._gnconnect)
	ENDIF
	CLEAR CLASS ALL
	ON SHUTDOWN
	ON ERROR
	IF _VFP.STARTMODE <> 2
		SET SYSMENU NOSAVE && Forcer menu VFP
		SET SYSMENU TO DEFAULT
		SET RESOURCE ON
		SET HELP ON
		SET DEVICE TO SCREEN
	ENDIF
	CLOSE DATABASE ALL
	RELEASE  ALL && public variables
	CANCEL
ENDPROC

* Ecrire dans un fichier ini
FUNCTION putprof AS INTEGER
	* Place a profile string into dksetup_ini
	LPARAMETER p_ini_name AS STRING, p_section AS STRING, p_fonction AS STRING, p_string AS STRING

	RETURN WritePrivateProfileString(m.p_section, m.p_fonction, m.p_string, m.p_ini_name)
ENDFUNC

* Lire dans un fichier ini
FUNCTION GETPROF AS STRING
	* Retrieve a profile string from dksetup_ini
	LPARAMETER p_ini_name AS STRING, p_section AS STRING, p_fonction AS STRING
	LOCAL cBuffer AS STRING

	cBuffer = REPLICATE(CHR(0),255)
	=GetPrivateProfileString(m.p_section, m.p_fonction, "", @m.cBuffer, LEN(m.cBuffer), m.p_ini_name)
	RETURN ALLTRIM(CHRTRAN(m.cBuffer, CHR(0), " "))
ENDFUNC

* Procdure de traitement des erreurs des procdures actions
PROCEDURE traiterr
	LPARAMETERS p_numero AS NUMBER, p_texte AS STRING, p_texte2 AS STRING, p_programme AS STRING, p_line AS STRING

	IF PCOUNT() > 4 AND VARTYPE(m.p_numero) == 'N' AND VARTYPE(m.p_texte) == 'C' AND VARTYPE(m.p_texte2) == 'C' AND VARTYPE(m.p_programme) == 'C' AND VARTYPE(m.p_line) == 'N'
		LOCAL cMessage AS STRING

		cMessage = "PROGRAMME:" + m.p_programme + CHR(13) + "ERREUR " + ALLTRIM(STR(m.p_numero)) + CHR(13);
			+ "Erreur : " + m.p_texte + CHR(13);
			+ "Code : " + m.p_texte2 + CHR(13);
			+ "Ligne : " + ALLTRIM(STR(m.p_line)) + CHR(13);
			+ "S.V.P. contactez le service technique avec le contenu de ce message.."
		=ecrit_trace("ERREUR " + ALLTRIM(STR(m.p_numero)) + " : " + m.p_texte + ' -- ' + m.p_texte2, 0)
	ENDIF
ENDPROC

**** Ecrit dans le fichier trace les infos passes en paramtre
PROCEDURE ecrit_trace()
	LPARAMETERS p_trace AS STRING, p_dossier AS INTEGER

	IF PCOUNT() > 1 AND VARTYPE(m.p_trace) == 'C' AND VARTYPE(m.p_dossier) == 'N'
		LOCAL cSql AS STRING , iSelect AS INTEGER

		iSelect = SELECT(0)
		cSql = [INSERT INTO trace (clefk_client, trace, clefk_reparation) values(] + transformer(_SCREEN._clepkUser) + ', ' + transformer(m.p_trace) + ', ' + transformer(m.p_dossier) + ')'
		IF _SCREEN._gnconnect > 0
			* Vrification si la connexion n'est pas bloque et si ncessaire attendre 30 secondes qu'elle se dbloque
			IF SqlPasBloque()
				=SQLEXEC(_SCREEN._gnconnect, m.cSql)
			ELSE
				_SCREEN._file_trace = _SCREEN._trace + DTOC(DATE(), 1) + "_" + _SCREEN._machine_name + "_" + PROGRAM(0) + ".log"
				=STRTOFILE(m.p_trace + CHR(13) + CHR(10), _SCREEN._file_trace, .T.)
			ENDIF
		ELSE
			_SCREEN._file_trace = _SCREEN._trace + DTOC(DATE(), 1) + "_" + _SCREEN._machine_name + "_" + PROGRAM(0) + ".log"
			=STRTOFILE(m.p_trace + CHR(13) + CHR(10), _SCREEN._file_trace, .T.)
		ENDIF
		SELECT(m.iSelect)
	ENDIF
ENDPROC

* Ouverture de la base de donne locale
PROCEDURE open_dbc
	LOCAL oException AS OBJECT;
		, cDB AS STRING;
		, cMessage AS STRING;
		, cChaineConnexion AS STRING;
		, iNbConnexion AS INTEGER;
		, iDebut AS INTEGER
	LOCAL ARRAY AConnexion[1]

	_SCREEN._dbcdatavfp = _SCREEN._disque + "DATAVFP.dbc"
	IF FILE(_SCREEN._dbcdatavfp)
		cDB = JUSTSTEM(_SCREEN._dbcdatavfp)
		IF NOT DBUSED(m.cDB)
			ON ERROR
			TRY
				OPEN DATABASE (_SCREEN._dbcdatavfp) SHARED
				=CURSORSETPROP("FetchSize",-1, 0)
				=CURSORSETPROP("FetchAsNeeded", .F., 0)
			CATCH TO m.oException
				cMessage = "La base DATAVFP est dj ouverte en mode EXCLUSIF, opration impossible"
				=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + m.cMessage, _SCREEN._locale + '_postgresql.log' +CHR(13)+CHR(10), 1)
				=raz_prg()
				IF INLIST(_VFP.STARTMODE, 3, 5)
					_VFP.QUIT
				ELSE
					QUIT
				ENDIF
			FINALLY
			ENDTRY
		ELSE
			SET DATABASE TO (m.cDB)
		ENDIF
		IF _SCREEN._gnconnect <= 0
			* Traitement de la chaine de connexion  la base sous PosTGreSql
			cChaineConnexion = ALLTRIM(GETPROF(_SCREEN._disque + "GLOBAL.INI", "Serveur", "ChaineConnexion"))
			IF NOT EMPTY(m.cChaineConnexion)
				iDebut = SECONDS()
				DO WHILE .T.
					DOEVENTS
					_SCREEN._gnconnect = SQLSTRINGCONNECT(m.cChaineConnexion, .T.)
					IF _SCREEN._gnconnect > 0
						=SQLSETPROP(_SCREEN._gnconnect, "ConnectTimeOut",30) && timeout 30 secondes
						* Connexion russie
						=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + 'Connexion N' + ALLTRIM(STR(_SCREEN._gnconnect)) + CHR(13) + CHR(10), _SCREEN._locale + '_postgresql.log', 1)
						EXIT
					ENDIF
					IF SECONDS() > m.iDebut + 15
						* Echec connexion
						EXIT
					ENDIF
					=Sleep(150)
				ENDDO
			ENDIF
		ENDIF
		IF _SCREEN._gnconnect > 0
			IF _SCREEN._debug <> "DEBUG"
				ON ERROR DO traiterr WITH ERROR(), MESSAGE(), PROGRAM(0)
			ELSE
				ON ERROR
			ENDIF
		ELSE
			=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + "La CONNEXION ODBC avec le SERVEUR SQL est impossible" + CHR(13) + CHR(10), _SCREEN._locale + '_postgresql.log', 1)
			=raz_prg()
			IF INLIST(_VFP.STARTMODE, 3, 5)
				_VFP.QUIT
			ELSE
				QUIT
			ENDIF
		ENDIF
	ELSE
		=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + "La base DATAVFP est introuvable" + CHR(13) + CHR(10), _SCREEN._locale + '_postgresql.log', 1)
		=raz_prg()
		IF INLIST(_VFP.STARTMODE, 3, 5)
			_VFP.QUIT
		ELSE
			QUIT
		ENDIF
	ENDIF
ENDPROC


* Fonction d'excution d'un programme exterieur
FUNCTION execute AS INTEGER
	**  Retourne  2  - mauvaise association,
	**            31 - aucune association sur l'extention
	**            29 - Echec de du chargement de l'appli
	**            30 - Application  occupe

	LPARAMETERS p_nomfich AS STRING, p_travrep AS STRING, p_parametre AS STRING, p_operation AS STRING

	RETURN IIF(EMPTY(m.p_nomfich) OR VARTYPE(m.p_nomfich) <> 'C';
		, -1;
		, ShellExecute(0;
		, IIF(VARTYPE(m.p_operation) == "C" AND NOT EMPTY(m.p_operation), ALLTRIM(m.p_operation), "Open");
		, ALLTRIM(m.p_nomfich);
		, IIF(VARTYPE(m.p_parametre) == "C", ALLTRIM(m.p_parametre), "");
		, IIF(VARTYPE(m.p_travrep) == "C", ALLTRIM(m.p_travrep), "");
		, 1);
		)
ENDFUNC

*****************************************************************************
*						     Procedure: maj_table_inc
*****************************************************************************
* cette procdure met  jour l'unique enregistrement de la vue p_alias sur la table autoincrment p_table
* en activant d'abord la proprit "sendupdates" puis en mettant  jour l'enregistrement en cours
* si la mise  jour est echoue, la procdure retourne -1,
* sinon elle retourne le N de la cl primaire autoincrmentation de la table p_table
FUNCTION maj_table_inc AS INTEGER
	LPARAMETERS p_inc_alias AS STRING, p_inc_table AS STRING

	IF PCOUNT() > 1 AND VARTYPE(m.p_inc_alias) == 'C' AND NOT EMPTY(m.p_inc_alias) AND USED(m.p_inc_alias) AND VARTYPE(m.p_inc_table) == 'C' AND NOT EMPTY(m.p_inc_table)
		LOCAL iRetour AS INTEGER;
			, nSelect AS INTEGER;
			, cClePrim AS STRING;
			, cSql AS STRING;
			, cValeur AS STRING;
			, cIncRequery AS STRING;
			, cChampNonNull AS STRING;
			, iNbChamp AS INTEGER;
			, iCount AS INTEGER;
			, cChamp AS STRING;
			, oIncAlias AS OBJECT;
			, iClePK AS INTEGER
		LOCAL ARRAY t_champs[1]

		iSelect = SELECT(0)
		iRetour = -1
		STORE '' TO cIncRequery, cClePrim
		p_inc_alias = LOWER(ALLTRIM(m.p_inc_alias))
		cClePrim = "ClePk"
		cIncRequery = "iclepk"
		cChampNonNull = ""
		STORE '' TO cChamp, cValeur
		IF NOT EMPTY(m.cChampNonNull)
			* Ajout de la mise  jour des champs qui ne peuvent pas tre nul. les champs sont remplis avec le caractre chr(0)
			iNbChamp = OCCURS(m.cChampNonNull, ';')
			IF m.iNbChamp > 0
				FOR iCount = 1 TO m.iNbChamp
					cChamp = m.cChamp + ',' + SUBSTR(m.cChampNonNull, ATC(';', m.cChampNonNull, m.iCount) + 1, ATC(';', m.cChampNonNull, m.iCount + 1) - ATC(';', m.cChampNonNull, m.iCount) - 1)
					cValeur = m.cValeur + ',' + "''"
				ENDFOR
			ELSE
				cChamp = ',' + m.cChampNonNull
				cValeur = ',' + "''"
			ENDIF
		ENDIF
		* Rcupration de la cl auto-incrment d'un nouvel enregistrement vierge
		cSql = [INSERT INTO ] + ALLTRIM(LOWER(m.p_inc_table)) + [ (] + ALLTRIM(m.cClePrim) + m.cChamp + [) VALUES(DEFAULT] + m.cValeur + [) RETURNING ] + m.cClePrim
		IF SqlEmet(m.cSql, 'c_sqlmajinc') > 0
			cValeur = 'c_sqlmajinc.' + m.cClePrim
			iRetour = &cValeur && iRetour contient la valeur de la cl primaire de l'INSERT SQL
			IF m.p_inc_alias = 'v_reparation'
				=ecrit_trace("REPARATION..(Sauve nouveau)", m.iRetour)
			ENDIF
			SELECT(m.p_inc_alias)
			* Mise  jour dans la vue courante de la cl primaire
			* Mise en memoire dans un objet du contenu de la vue
			* car il faut la recharger avec le contenu du nouvel enregistrement
			* sinon VFP crera un nouvel enregistrement car pour lui le
			* contenu de la vue aura chang surtout le contenu de la cl primaire
			SCATTER NAME oIncAlias MEMO && copie
			* suppression de la cl primaire et dateheure afin de ne pas les modifier dans la vue p_inc_alias et dclencher une erreur ODBC lors de l'criture dans la table correspondante
			=REMOVEPROPERTY(m.oIncAlias, 'dateheure')
			=REMOVEPROPERTY(m.oIncAlias, m.cClePrim)
			* remplacement des dates vides VFP par des NULL
			iNbChamp = AMEMBERS(m.t_champs, m.oIncAlias)
			FOR iCount = 1 TO m.iNbChamp
				* Remplacer les dates vides par .NULL.
				IF TYPE(m.t_champs[m.iCount]) == 'D' OR TYPE(m.t_champs[m.iCount]) == 'T'
					IF LOWER(m.t_champs[m.iCount]) <> 'dateheure'
						cChamp = EVALUATE(m.t_champs[m.iCount])
						IF EMPTY(m.cChamp)
							cChamp = "m.oIncAlias." + m.t_champs[m.iCount]
							&cChamp= .NULL.
						ENDIF
					ENDIF
				ENDIF
			ENDFOR
			SELECT (m.p_inc_alias)
			=TABLEREVERT(.T., m.p_inc_alias)
			&cIncRequery = m.iRetour
			=REQUERY(m.p_inc_alias)
			GATHER NAME m.oIncAlias MEMO
			* mise  jour de la vue
			* Sauvegarde des donnes de la vue dans l'enregistrement nouvellement cre de la table p_inc_table
			=maj_table(m.p_inc_alias, .F.)
			oIncAlias = NULL
		ENDIF
		USE IN SELECT('c_sqlmajinc')
		SELECT (m.iSelect)
		RETURN m.iRetour
	ELSE
		RETURN -1
	ENDIF
ENDFUNC

* Fonction de mise  jour du contenu d'une vue vers les tables parents
FUNCTION maj_table AS Boolean
	LPARAMETERS p_vue AS STRING, p_tous AS Boolean

	IF PCOUNT() > 0 AND VARTYPE(m.p_vue) == 'C' AND NOT EMPTY(m.p_vue) AND USED(m.p_vue)
		LOCAL lretour AS Boolean , iSelect AS INTEGER

		* p_vue contient le nom de la vue servant  mettre  jour les tables
		p_vue = LOWER(ALLTRIM(m.p_vue))
		* p_tous .T. tous les enregistrements sont mis  jour, .F. seul l'enregistrement courant est mis  jour
		iSelect = SELECT(0)
		SELECT (m.p_vue)
		IF VARTYPE(m.p_tous) == 'L' AND m.p_tous
			IF NOT CURSORSETPROP("sendupdates", .T., m.p_vue)
				=ecrit_trace("<ERREUR>DROIT DE MISE A JOUR CURSEUR IMPOSSIBLE", 0)
			ELSE
				IF NOT TABLEUPDATE(1, .T., m.p_vue)
					=AERROR(t_Error)
					=ecrit_trace("<ERREUR>MISE A JOUR CURSEUR IMPOSSIBLE-->" + m.t_Error[2], 0)
					RELEASE t_Error
					=TABLEREVERT(.T., m.p_vue)
				ELSE
					lretour = .T.
				ENDIF
			ENDIF
			=CURSORSETPROP("sendupdates", .F., m.p_vue)
		ELSE
			IF NOT CURSORSETPROP("sendupdates", .T., m.p_vue)
				=ecrit_trace("<ERREUR>DROIT DE MISE A JOUR CURSEUR IMPOSSIBLE", 0)
			ELSE
				IF NOT TABLEUPDATE(0, .T., m.p_vue)
					=AERROR(t_Error)
					=ecrit_trace("<ERREUR>MISE A JOUR ENREGISTREMENT IMPOSSIBLE-->" + m.t_Error[2], 0)
					RELEASE t_Error
					=TABLEREVERT(.T., m.p_vue)
				ELSE
					lretour = .T.
				ENDIF
			ENDIF
			=CURSORSETPROP("sendupdates", .F., m.p_vue)
		ENDIF
		SELECT (m.iSelect)
		RETURN m.lretour
	ELSE
		RETURN .F.
	ENDIF
ENDFUNC

*****************************************************************************
*						     Procedure: ins_table_inc
*****************************************************************************
* cette procdure met  jour l'enregistrement courant de la vue p_alias sur la table autoincrment p_table
* en activant d'abord la proprit "sendupdates" puis en mettant  jour l'enregistrement en cours
* si la mise  jour est echoue, la procdure retourne -1,
* sinon elle retourne le N de la cl primaire autoincrmentation de la table p_table
FUNCTION ins_table_inc AS INTEGER
	LPARAMETERS p_inc_alias AS STRING, p_inc_table AS STRING

	IF PCOUNT() > 1 AND VARTYPE(m.p_inc_alias) == 'C' AND NOT EMPTY(m.p_inc_alias) AND USED(m.p_inc_alias) AND VARTYPE(m.p_inc_table) == 'C' AND NOT EMPTY(m.p_inc_table)
		LOCAL iRetour AS INTEGER;
			, iSelect AS INTEGER;
			, cClePrim AS STRING;
			, cSql AS STRING;
			, cValeur AS STRING

		iSelect = SELECT(0)
		iRetour = -1
		p_inc_alias = LOWER(ALLTRIM(m.p_inc_alias))
		cClePrim = "clepk"
		cSql = genere_insert(m.p_inc_alias, m.p_inc_table, m.cClePrim)
		IF NOT EMPTY(m.cSql) AND SqlEmet(m.cSql, 'c_sqlinsert') > 0
			cValeur = 'c_sqlinsert.' + m.cClePrim
			iRetour = &cValeur
		ENDIF
		USE IN SELECT('c_sqlinsert')
		SELECT (m.iSelect)
		RETURN m.iRetour
	ELSE
		RETURN -1
	ENDIF
ENDFUNC

FUNCTION genere_insert(p_alias AS STRING, p_table AS STRING, p_clepk AS STRING, p_pasretourpk AS Boolean) AS STRING
	IF PCOUNT() > 2 AND VARTYPE(m.p_alias) == 'C' AND NOT EMPTY(m.p_alias) AND USED(m.p_alias) AND VARTYPE(m.p_table) == 'C' AND NOT EMPTY(m.p_table) AND VARTYPE(m.p_clepk) == 'C' AND NOT EMPTY(m.p_clepk)
		LOCAL ARRAY la_Champs[1,18], la_table[1,18]
		LOCAL li_nombre_de_champs AS INTEGER;
			, li_i AS INTEGER;
			, c_sqlinsert AS STRING;
			, ls_champ AS STRING;
			, ls_liste AS STRING;
			, iSelect AS INTEGER

		iSelect = SELECT(0)
		SELECT (m.p_alias)
		ls_liste = CURSORGETPROP("UpdatableFieldList", m.p_alias)
		li_nombre_de_champs = AFIELDS(la_Champs)
		c_sqlinsert = [INSERT INTO ] + LOWER(m.p_table) + [ (]
		FOR li_i=1 TO m.li_nombre_de_champs
			IF m.la_Champs[li_i, 2] = "G" OR ALLTRIM(LOWER(m.la_Champs[li_i,1])) == ALLTRIM(m.p_clepk) OR LOWER(m.la_Champs[li_i,1]) = "dateheure" OR LOWER(m.la_Champs[li_i,1]) = "inactif" OR NOT UnChamptable(m.p_alias, m.la_Champs[li_i,1], m.ls_liste)&& ignorer champ/colonne dateheure et inactif
				LOOP
			ENDIF
			c_sqlinsert = m.c_sqlinsert + [ ] + LOWER(m.la_Champs[li_i, 1]) + [,]
		NEXT
		* Suppression du dernier caractre si c'est ","
		c_sqlinsert = IIF(RIGHT(m.c_sqlinsert, 1) == ",", LEFT(m.c_sqlinsert, LEN(m.c_sqlinsert) - 1), m.c_sqlinsert) + [) VALUES (]
		FOR li_i=1 TO m.li_nombre_de_champs
			IF m.la_Champs[li_i, 2] = "G" OR ALLTRIM(LOWER(m.la_Champs[li_i,1])) == ALLTRIM(m.p_clepk) OR LOWER(m.la_Champs[li_i,1]) = "dateheure" OR LOWER(m.la_Champs[li_i,1]) = "inactif" OR NOT UnChamptable(m.p_alias, m.la_Champs[li_i,1], m.ls_liste) && ignorer champ/colonne dateheure et inactif
				LOOP
			ENDIF
			* Remplacer les dates vides par .NULL.
			ls_champ = EVALUATE(la_Champs[li_i, 1])
			IF m.la_Champs[li_i, 2] = 'D' OR m.la_Champs[li_i, 2] = 'T'
				ls_champ = IIF(EMPTY(m.ls_champ), .NULL., m.ls_champ)
			ENDIF
			c_sqlinsert = m.c_sqlinsert + [ ] + transformer(m.ls_champ, m.la_Champs[li_i, 6]) + [,]
		NEXT
		c_sqlinsert = IIF(RIGHT(m.c_sqlinsert, 1) == ",", LEFT(m.c_sqlinsert, LEN(m.c_sqlinsert) - 1), m.c_sqlinsert) + IIF(VARTYPE(m.p_pasretourpk) == 'L' AND m.p_pasretourpk, [)], [) RETURNING ] + ALLTRIM(m.p_clepk))
		SELECT (m.iSelect)
		RETURN m.c_sqlinsert
	ELSE
		RETURN ''
	ENDIF
ENDFUNC

* Fonction pour savoir si le champ p_champ existe dans la table p_table
FUNCTION UnChamptable AS Boolean
	LPARAMETERS p_table AS STRING, p_champ AS STRING, p_liste AS STRING

	IF PCOUNT() > 1 AND VARTYPE(m.p_table) == "C" AND VARTYPE(m.p_champ) == "C"
		LOCAL lretour AS Boolean;
			, iCount AS INTEGER;
			, iPosedeb AS INTEGER;
			, iPosFin AS INTEGER

		* Mise en mmoire des champs UPDATABLE (une liste de nom de champ spars par une virgule)
		p_liste = IIF(VARTYPE(m.p_liste) <> 'C' OR EMPTY(m.p_liste), CURSORGETPROP("UpdatableFieldList", m.p_table), LOWER(ALLTRIM(m.p_liste)))
		IF NOT EMPTY(m.p_liste)
			p_champ = LOWER(ALLTRIM(m.p_champ))
			* Dnombrage du nombre de sparateur
			FOR iCount = 0 TO OCCURS(",", m.p_liste)
				iPosDep = IIF(m.iCount = 0, 1, ATC(",", m.p_liste, m.iCount) + 1)
				iPosDep = IIF(EMPTY(m.iPosDep), 1, m.iPosDep)
				iPosFin = ATC(",", m.p_liste, m.iCount + 1)
				cChamp = IIF(m.iPosFin > 0, LOWER(ALLTRIM(SUBSTR(m.p_liste, m.iPosDep, m.iPosFin - m.iPosDep))), LOWER(ALLTRIM(SUBSTR(m.p_liste, m.iPosDep))))
				IF m.p_champ == m.cChamp
					lretour = .T.
					EXIT
				ENDIF
			ENDFOR
		ENDIF
		RETURN m.lretour
	ELSE
		RETURN .F.
	ENDIF
ENDFUNC

* Fonction de formatage des champs en un champ de type texte pour l'utilisation dans les requtes SQL EXEC
FUNCTION transformer(t_champ, tl_en_binaire AS Boolean) AS STRING
	IF PCOUNT() > 0
		LOCAL ls_return AS STRING, cOldPoint AS STRING, li_i  AS INTEGER

		IF ISNULL(m.t_champ)
			ls_return = "NULL"
		ELSE
			DO CASE
				CASE VARTYPE(m.tl_en_binaire) == 'L' AND m.tl_en_binaire
					* cas du binaire a transformer en hexadecimal
					IF LEN(m.t_champ) > 1
						ls_return = "0x"
						FOR li_i=1 TO LEN(m.t_champ)
							ls_return = m.ls_return + RIGHT(TRANSFORM( ASC(SUBSTR(m.t_champ, m.li_i, 1)), "@0"), 2)
						NEXT
					ELSE
						ls_return = "''"
					ENDIF

				CASE VARTYPE(m.t_champ) $ "C" &&MV"
					ls_return = ALLTRIM(m.t_champ)
					ls_return = STRTRAN(m.ls_return, CHR(92), CHR(92)+CHR(92)) && \ en \\
					ls_return = STRTRAN(m.ls_return, CHR(39), CHR(39)+CHR(39)) && ' en \'
					*				ls_return = STRTRAN(ls_return, CHR(39), CHR(92)+CHR(39)) && ' en \'
					ls_return = "'" + m.ls_return + "'"

				CASE VARTYPE(m.t_champ) == "Y" &&YBFI"
					ls_return = ALLTRIM(STR(m.t_champ))

				CASE VARTYPE(m.t_champ) == "N" &&YBFI"
					*cOldPoint = SET("Point")
					*SET POINT TO '.'
					ls_return = ALLTRIM(TRANSFORM(m.t_champ))
					*SET POINT TO m.cOldPoint

				CASE VARTYPE(m.t_champ) == "D"
					ls_return = "'" + LEFT(TTOC(m.t_champ, 3), 10) + "'"

				CASE VARTYPE(m.t_champ) == "T"
					ls_return = "'" + TTOC(m.t_champ, 3) + "'"

				CASE VARTYPE(m.t_champ) == "L"
					* boolean .T. = 1
					ls_return = ICASE(m.t_champ, "'TRUE'", "'FALSE'")

				CASE VARTYPE(m.t_champ) == "Q"
					* cas particulier en binaire directement du varchar binary
					ls_return = ICASE(LEN(m.t_champ) > 1, "0x" + TRANSFORM(m.t_champ), "''")

				OTHERWISE
					ls_return = "NULL"
			ENDCASE
		ENDIF
		RETURN m.ls_return
	ELSE
		RETURN "NULL"
	ENDIF
ENDFUNC

* Fonction de gnration de la chaine SQL pour transfrer par un INSERT INTO matableinsert (*) SELECT * FROM matablefrom WHERE macondition
FUNCTION genere_sql_transfert AS STRING
	LPARAMETERS p_demande AS INTEGER, p_tablefrom AS STRING, p_tableinsert AS STRING, p_tablestructure AS STRING
	* p_tablefrom table source
	* p_tableinsert table mise  jour
	* p_tablestructure table servant de support pour les champs  recopier

	IF PCOUNT() > 0 AND VARTYPE(m.p_demande) == 'N' AND VARTYPE(m.p_tablefrom) == 'C' AND NOT EMPTY(m.p_tablefrom) AND VARTYPE(m.p_tableinsert) == 'C' AND NOT EMPTY(m.p_tableinsert) AND VARTYPE(m.p_tablestructure) == 'C' AND NOT EMPTY(m.p_tablestructure)
		LOCAL ARRAY la_Champs[1,18], la_table[1,18]
		LOCAL li_nombre_de_champs AS INTEGER;
			, li_i AS INTEGER;
			, c_sqlinsert AS STRING;
			, cSql AS STRING;
			, ls_champ AS STRING;
			, ls_liste AS STRING

		STORE '' TO cSql, c_sqlinsert
		* rcupration de la structure de la table INSERT
		IF SQLCOLUMNS(_SCREEN._gnconnect, LOWER(m.p_tablestructure), 'FOXPRO', 'c_insert') > 0
			cSql = [INSERT INTO ] + LOWER(m.p_tableinsert) + [ (]
			SELECT c_insert
			SCAN
				IF field_type == "G" OR ALLTRIM(LOWER(field_name)) == 'cle' OR LOWER(field_name) = "dateheure" OR LOWER(field_name) = "inactif" && ignorer champ/colonne dateheure et inactif
				ELSE
					c_sqlinsert = m.c_sqlinsert + [ ] + ALLTRIM(LOWER(field_name)) + [,]
				ENDIF
			ENDSCAN
			c_sqlinsert = IIF(RIGHT(m.c_sqlinsert, 1) == ",", LEFT(m.c_sqlinsert, LEN(m.c_sqlinsert) - 1), m.c_sqlinsert)
			cSql = m.cSql + m.c_sqlinsert + [) SELECT ]  + m.c_sqlinsert + [ FROM ] + LOWER(m.p_tablefrom) + [ WHERE demande = ] + transformer(m.p_demande) + [ AND inactif = 0]
		ENDIF
		USE IN SELECT('c_insert')
		RETURN m.cSql
	ELSE
		RETURN ''
	ENDIF
ENDFUNC

* Fonction d'mission des commandes SQL auprs du SGBDR
* Retourne -2 si action impossible ou erreur de connexion
* Retourne -1 si curseur p_curseur non cr ou si action sans curseur impossible
* retourne le nombre d'enregistrements du curseur p_curseur, ou le rsultat de l'action sans curseur
* Fonction d'mission des commandes SQL auprs du SGBDR
* Retourne -2 si action impossible ou erreur de connexion
* Retourne -1 si curseur p_curseur non cr ou si action sans curseur impossible
* retourne le nombre d'enregistrements du curseur p_curseur, ou le rsultat de l'action sans curseur
FUNCTION SqlEmet(p_Action AS STRING, p_curseur AS STRING, p_no_use_curseur AS Boolean) AS INTEGER
	LOCAL iRetour AS INTEGER, lExit AS Boolean, oSqlErreur AS OBJECT

	iRetour = 0
	* fermeture d'un ventuel curseur portant le mme nom
	IF VARTYPE(m.p_no_use_curseur) == 'L' AND m.p_no_use_curseur = .F. AND VARTYPE(m.p_curseur) == 'C' AND NOT EMPTY(m.p_curseur) AND USED(m.p_curseur)
		USE IN SELECT(m.p_curseur)
	ENDIF
	IF VARTYPE(m.p_Action) == "C"
		* Vrification si la connexion n'est pas bloque
		iRetour = IIF(SqlPasBloque(), IIF(m.p_no_use_curseur = .F., SQLEXEC(_SCREEN._gnconnect, m.p_Action, m.p_curseur), SQLEXEC(_SCREEN._gnconnect, m.p_Action)), -2)
		IF (m.p_no_use_curseur = .F. AND m.iRetour = -1) OR (m.p_no_use_curseur = .T. AND m.iRetour < 1)
			iRetour = -2
			=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + "ERREUR excution SQL " + m.p_Action + CHR(13) + CHR(10), _SCREEN._locale + '_postgresql.log', 1)
		ELSE
			iRetour = IIF(m.p_no_use_curseur = .F. AND USED(m.p_curseur), RECCOUNT(m.p_curseur), m.iRetour)
		ENDIF
	ELSE
		=STRTOFILE(TTOC(DATETIME()) + ': ' + ALLTRIM(STR(_VFP.PROCESSID)) + '-->' + "ERREUR excution SQL paramtre p_action non chaine de caractre" + CHR(13) + CHR(10), _SCREEN._locale + '_postgresql.log', 1)
	ENDIF
	RETURN m.iRetour
ENDFUNC

* Fonction de vrification et de renvoi de l'tat Busy de la connexion SQL
FUNCTION SqlPasBloque AS Boolean
	LOCAL lretour AS Boolean , iDebut AS INTEGER , iTimeOut AS INTEGER

	iTimeOut = 30
	iDebut = SECONDS()
	DO WHILE .T.
		DOEVENTS
		IF NOT SQLGETPROP(_SCREEN._gnconnect, 'ConnectBusy')
			lretour = .T.
			EXIT
		ENDIF
		IF SECONDS() > m.iDebut + m.iTimeOut
			lretour = .F.
			EXIT
		ENDIF
		=Sleep(150)
	ENDDO
	RETURN m.lretour
ENDFUNC

FUNCTION maj_titre_fenetre
	LOCAL cOpe AS STRING, cSql AS STRING

	cOpe = SPACE(5) + "Oprateur : " + IIF(EMPTY(_SCREEN._clepkUser), 'N.C.', lire_nom_userId(_SCREEN._clepkUser))
	MODIFY WINDOW SCREEN TITLE EVL(_SCREEN._title, SPACE(0)) + m.cOpe
ENDFUNC

* Lire les coordonnes de l'utilisateur pour les afficher dans foxincloud-status
FUNCTION lire_nom_userId AS STRING
	LPARAMETERS p_iduser AS NUMBER

	LOCAL cReturn AS STRING, cSql AS STRING, iSelect AS INTEGER

	cReturn = 'N.C.'
	iSelect = SELECT(0)
	IF PCOUNT() > 0 AND VARTYPE(m.p_iduser) = 'N'
		DO CASE

			CASE m.p_iduser = -1
				cReturn = 'DEMO USER'

			CASE m.p_iduser = 0
				cReturn = 'Anonymous'

			OTHERWISE
				* Rcupration du nom de l'oprateur
				cSql = [SELECT CAST('(' || TRIM(profil) || ') ' || TRIM(societe) || ' ' || TRIM(marque) || ' - ' || TRIM(nom) || ' ' || TRIM(prenom) AS CHAR(120)) AS operateur FROM client WHERE clepk = ];
					+ transformer(m.p_iduser) + [ AND inactif = 0]
				cReturn = IIF(SqlEmet(m.cSql, 'c_nom_ope') > 0, ALLTRIM(c_nom_ope.operateur), m.cReturn)
				USE IN SELECT('c_nom_ope')
		ENDCASE
	ENDIF
	SELECT (m.iSelect)
	RETURN m.cReturn
ENDFUNC

PROCEDURE ferme_session
	=ecrit_trace("FERMETURE SESSION " + ALLTRIM(STR(_SCREEN._clepkUser)), 0)
	WITH _SCREEN
		STORE 0 TO ._clepkUser
	ENDWITH
	=maj_titre_fenetre()
ENDPROC

FUNCTION droitacces as Integer
LPARAMETERS p_cleUser as Integer
RETURN 4 && tout accs
ENDFUNC
