/****************************************************************





Bienvenue dans le fichier JavaScript de votre application !
Vous pouvez régler FoxInCloud ci-dessus ou, si nécessaire, écrire votre propre JavaScript (selon Prototype.js ou jQuery)
Vous pouvez partager ce fichier entre atfTest et atfProd :
par exemple, éditer et mettre au point ...\site\atfTest\atf.js puis le copier vers ...\site\atfProd\atf.js
/!\ Ce fichier est encodé en UTF-8 ; utilisez un éditeur supportant UTF-8 tel que Sublime Text, NotePad++ ou PSpad
*****************************************************************/
jQuery.extend(FoxInCloud, {

  CGI: 'atf',
	// Extension de scriptmap pour l'application (code de l'application par défaut)

	/****************************************************************
	
	
	
	
	
	Réglages de FoxInCloud
	Modifiez les valeurs comme il vous convient (entre ':' et ',') 
	La syntaxe des littéraux est la même que dans VFP, sauf Booléen [true|false], Null [null] et Date [new Date(an, mois, jour[, heures[, minutes[, secondes)]]]]
	De nouvelles options peuvent apparaître dans de futures versions de FoxInCloud
	Pour tirer parti d'une NOUVELLE OPTION dans vos application(s) Web existantes, copiez-la simplement dans votre(s) fichier(s) atf.js, au même emplacement
	*****************************************************************/

  requestTimeoutDev: 600,
	// DÉVELOPPEMENT : délai en secondes avant que la requête n'expire 
	// quand le délai expire, un message apparaît dans la page HTML et la requête est perdue  
	// un délai assez long est recommandé pour vous laisser le temps de déboguer le cas échéant 
 
 	requestTimeoutProd: 25,
	// PRODUCTION : délai en secondes avant que la requête n'expire 
	// quand le délai expire, un message apparaît dans la page HTML et la requête est perdue  
	// réglez un délai au moins aussi long que la valeur de 'Timeout' dans votre fichier wc.ini  

  requestWaitPic: true,
	// Requête: afficher le picto d'attente de la réponse du serveur
	// vous pouvez changer le picto d'attente dans votre sous-classe de aw.vcx!awFrm

  requestWaitPicDelay: .5,
	// requête: délai en secondes avant d'afficher le picto d'attente -- <=0 pour afficher tout de suite

  requestFormOpacity: .9,
	// requête: % d'opacité du formulaire pendant la requête -- <=0 ou > 1 pour ne rien changer

  autoBlurDelay: 20,
	// <input type="text..."> (VFP textbox) : délai en secondes pour la soumission automatique -- <=0 pour inhiber
	// Fonctionne pour les contrôles VFP avec .wlValidAutoNot = .F.

  inputAlwaysBlurOnReturn: false,
	// <input type="text ..."/> (VFP textbox): toujours envoyer la valeur au serveur quand l'utilisateur presse la touche enter, même si la valeur n'a pas changé

  inputTextDateSelector: 'input.awDate',
	// <input type="text"/> affichant une date : sélecteur CSS
	// FoxInCloud attribue automatiquement class="awDate" aux textBox affichant une date  (utilisateur avec la licence complète : modify command awHTML > awHTMLgen.getHTML_txt())

  dateSeparator: '/',
	// <input type="text"/> affichant une date : séparateur

  dateFormat: 'day/month', // 'day/month' || 'month/day'
  // <input type="text"/> affichant une date : format de saisie

  centuryRollover: 20,
	// <input type="text"/> affichant une date : Retirer un siècle aux dates dont l'année est > année courante + this.centuryRollover  

  inputTextBackColor: false,
	// <input type="text"/> : changer automatiquement la couleur d'arrière plan 

  gridRowChangeDelay: 0.5,
	// grille : lorsque l'utilisateur navigue dans les lignes avec le clavier (flèches haut bas), délai en secondes avant d'envoyer l'événement changement de ligne au serveur -- <=0 pour envoyer tout de suite

  gridRowChangeDelayClicked: 0,
  // grille : lorsque l'utilisateur navigue dans les lignes d'une grille avec sa souris, délai en secondes avant d'envoyer l'événement changement de ligne au serveur -- <=0 pour envoyer tout de suite

  gridColChangeDelay: 0.5,
  // grille : délai en secondes avant d'envoyer l'événement changement de colonne -- <=0 pour envoyer tout de suite

  gridDateEmpty: '/ /',
	// Chaîne apparaissant dans le cellules de grille dont la valeur est une date vide ou nulle 

  gridDateTimeEmpty: '/ / ::',
	// Chaîne apparaissant dans le cellules de grille dont la valeur est une date et heure vide ou nulle

  pageEffectUser: true,
	// pageFrame: faire un effet de transition si la page est activée par l'utilisateur

  pageEffectServer: true,
	// pageFrame: faire un effet de transition si la page est activée par le serveur

  visibleEffect: true, // V 2.10
  // faire un effet de transition quand la visibilité d'un objet change

  imgSrcEffect: true, // V 2.10
  // image: faire un effet de transition quand la source de l'image change

  effectDuration: 1.5, // V 2.10
  // durée par défaut des effets de transition

  customErrorMsgHeader: function(standardErrorMsgHeader){ // V 2.10
  },
  // Toute valeur non vide retournée par cette méthode remplace l'en-tête de message d'erreur standard de FoxInCloud
  // ["Désolé, le serveur FoxInCloud a produit une erreur inattendue ..."]
  // Exemple d'implémentation (le HTML est supporté):
  // return '<p>votre application bien aimée a pris <i>une petite pause<i> ... <img src="images/foxincloud-logo-head-32.png">...<p>';

  customErrorMsgBody: function (standardErrorMsgBody){ // V 2.10
  },
  // Toute valeur non vide retrounée par cette méthode remplace le message d'erreur standard que FoxInCloud
  // génère soit côté client (navigateur), ou côté serveur.
  // Pour voir le type de message d'erreur que FoxInCloud peut générer, cherchez 'this.Error' dans FoxInCloud.js
  // Exemples d'implémentation:
  // - exemple 1 : remplacer 'FoxInCloud' par le nom de votre client (/FoxInCloud/ig est une expression régulière) :
  // return standardErrorMsgBody.replace(/FoxInCloud/ig, 'Nom du Client');
  // - exemple 2 : génére un message d'erreur fixe (le HTML est supporté) :
  // return '<p>Veuillez contacter le responsable de l'application.</p>';

  customErrorMsgInDevMode: false, // V 2.10
  // Pour voir le résultat de this.customErrorMsgHeader() et this.customErrorMsgBody() en cours de développement (en utilisant une URL comme http://localhost/atfTest/...), réglez cette valeur à true.
  // Régler cette valeur à true est recommendé pendant que vous développez les méthodes this.customErrorMsgHeader() et this.customErrorMsgBody() ci-dessus.
  // * En développement, le message d'erreur standard FoxInCloud prend le pas sur ce que retrounent les méthodes this.customErrorMsg*(), sauf si vous réglez this.customErrorMsgInDevMode à true
  // * En production, l'utilisateur voit toujours - si elles sont implémentées - le résultat des méthodes this.customErrorMsg*() ci-dessus, quelque soit le réglage de this.customErrorMsgInDevMode
  // Pour tester facilement this.customErrorMsg*(), ouvrez les outils de développement de votre navigateur (comme Firebug dans Firefox), et tapez dans la ligne de commande de la console:
  // FoxInCloud.Error(yourErrorMsgBody);

  onKeyLabels: "ctrl+A, ctrl+F, ctrl+O, ctrl+P, ctrl+S", // V 2.10
  // Combinations ON KEY LABEL que vous utilisez dans votre application et pour lesquelles vous voulez supprimer le comportement par défaut du navigateur.
  // (insensible à la casse)
  // Cette liste séparée par des virgules étant analysée dynamiquement, vous pouvez la modifier pendant un événement utilisateur dans votre code VFP en écrivant:
  // local loAJAX && as awAJAX of awServer.prg && licence complète
  // =wlAJAX(@m.loAJAX) and m.loAJAX.cScriptJSadd([FoxInCloud.onKeyLabels = FoxInCloud.onKeyLabels + ", ctrl+A, ctrl+F, ctrl+S, ctrl+O, ctrl+P, ctrl+Z";])
  // Note : les navigateurs peuvent avoir des comportements différents ; testez en détails ! https://bugs.chromium.org/p/chromium/issues/detail?id=33056

  AttribSet_: function ( // V 2.20
    element
  , attribute
  , value
  ){
    // return true n'exécute pas la méthode FoxInCloud par défaut
  },
  // Règle la valeur d'un attribut d'un élément HTML - à implémenter dans atf.js

  RequestSend_ante: function ( // V 2.20
    url // URL à laquelle la requête va être envoyée
  , element // élément du DOM HTML qui fut la cible de l'événement utilisateur le cas échéant
  , value // valeur de l'élément le cas échéant
  , sync // la requête va être envoyée en synchrone
  ) {
  // Votre code ici
  },
  // Exécuté juste avant d'envoyer une requête AJAX au serveur.
  // Vous pouvez utiliser cette méthode pour ajouter des paramètres à l'enveloppe POST ; pour ce faire, ajouter du code comme:
  // this.parameters['uneClé'] = uneValeur;
  // Côté serveur, vous pouvez retrouver ce paramètre à tout endroit de votre code VFP :
  // local oRequest as wwRequest of wwRequest.prg
  // uneValeur = iif(wlRequest(@m.oRequest), Cast(m.oRequest.Form('uneClé') as <type destination>), .null.)
  // /!\ les dates demandent une conversion préalable en littéral VFP:
  // this.parameters['uneClé'] = this.RequestSend_sDate(uneDateJavaScript);
  // vous pourriez aussi, avec une extrême prudence, surcharger les paramètres réglés par FoxInCloud:
  // this.parameters['vpw'] = document.documentElement.clientWidth * 1.5; // ViewPortWidth // simule une surface visible plus large

  junk: null // inutile mais laisser ici !
});


/****************************************************************

Si nécessaire, ajoutez ci-après le code javascript additionnel pour votre application ...
*****************************************************************/
